﻿Default_UpdateInterval = 0.01;
Align_UpdateInterval = 0.01;

local nameWordDeath, rankWordDeath, IconWordDeath, cost, isFunnel, powerType, castTime, minRange, maxRange  = GetSpellInfo("Shadow Word: Death");
local IconWordDeath2 = "Interface\\ICONS\\Spell_Shadow_DemonicFortitude.blp";
local highlight = "Interface\\PaperDollInfoFrame\\UI-GearManager-ItemButton-Highlight.blp";

TimeSinceSWD = 0;
defaultText="";
TimeSinceLastUpdate = 0;
function SWD_OnLoad()
	CheckGlyphs();
	HasSWD();
	SWD:RegisterEvent("VARIABLES_LOADED");
	SWD:RegisterEvent("ADDON_LOADED");
	SWD:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	SWD:RegisterEvent("GLYPH_ADDED");
	SWD:RegisterEvent("GLYPH_REMOVED");
	SWD:RegisterEvent("GLYPH_UPDATED");
	SWD:RegisterEvent("GLYPH_ENABLED");
	SWD:RegisterEvent("GLYPH_DISABLED");
	SWD:RegisterEvent("PLAYER_LOGIN");
	SWD:RegisterEvent("LEARNED_SPELL_IN_TAB");


	SWDTexture:SetTexture(IconWordDeath2)
	SWDTexture:Show()
	SWDHighlight:SetTexture(highlight)
	SWDHighlight:Hide()
	SWDTEXT:SetText(defaultText)
	SWDTEXT:Show()
	didReset = false;
	didCast = false;
	SWD:SetUserPlaced(true);
	SWD:ClearAllPoints()
	if(swdx ~= nil and swdr ~= nil) then
	SWD:SetPoint(swdr, nil, swdr, swdx, swdy);
	else
	SWD:SetPoint("BOTTOM", nil, "BOTTOM", 10, 100);
	end
	SWD:SetClampedToScreen( true )
	SWD:RegisterForDrag("LeftButton");
	SWD:EnableMouse(true);
	CheckPlayerCooldown()
	SWDTexture:SetVertexColor(1, 1, 1);
end
function saveVariable()
	point, relativeTo, relativePoint, xOfs, yOfs = SWD:GetPoint()
	swdx=xOfs;
	swdy=yOfs;
	swdr=point;
end
function SWD_SetDText(locked)
	point, relativeTo, relativePoint, xOfs, yOfs = SWD:GetPoint()
	swdx=xOfs;
	swdy=yOfs;
	swdr=point;
	if (locked) then
		defaultText="";
		SWDTEXT:SetText(defaultText);
	else
		defaultText="|cffffffffMove|r";
		SWDTEXT:SetText(defaultText);
	end
end
count=0
time1=0
function SWD_OnUpdate(elapsed)
		TimeSinceLastUpdate = TimeSinceLastUpdate + elapsed;
		while (TimeSinceLastUpdate > Align_UpdateInterval) do
			if(didCast or didReset or onCooldown)then
				CheckPlayerCooldown();
			end
			if(hasSWD)then
				local mhealth = UnitHealthMax("target");
				local health = UnitHealth("target");
				local percentage = health/mhealth;
				if(UnitCanAttack("player","target") and percentage~=0 and percentage < 0.25) then
					SWDHighlight:Show()
				else
					SWDHighlight:Hide()
				end
			end
			skip = TimeSinceLastUpdate/Align_UpdateInterval;
			if(skip >= 3) then
				TimeSinceLastUpdate=TimeSinceLastUpdate-((skip-3)*Align_UpdateInterval);
			end
			TimeSinceLastUpdate = TimeSinceLastUpdate-Align_UpdateInterval;
		end
end
onCooldown=false
didCast = false;
didReset = false;
lastCast=-1
function SWD_OnEvent(self, event, ...)
	if(event == "UNIT_SPELLCAST_SUCCEEDED") then
		local arg1, arg2, arg3, arg4, arg5 = ...;
		if(arg1=="player" and arg5 == 32379 and lastCast ~= arg4) then
			if(didReset)then                                                                
				didReset = false;
			end
			TimeSinceSWD=GetTime()-0.02;
			didCast = true;
			lastCast=arg4
		end
	elseif(strfind(event,"^GLYPH_")~=nil)then
		CheckGlyphs()
		CheckPlayerCooldown()
	elseif(event == "LEARNED_SPELL_IN_TAB" or event == "PLAYER_LOGOUT") then
		HasSWD()
		CheckPlayerCooldown()
	elseif(event == "PLAYER_LOGIN") then
		SWD_OnLoad()
	elseif(event == "ADDON_LOADED" and ...== "SWD") then
		SWD_OnLoad()
	end
end
	
lastCooldwn = 0
stayGreen = 0
cooldownTime = 10
glyphEnabled = false;
li=0
hasSWD=true
function HasSWD()
	start, duration, enabled = GetSpellCooldown("Shadow Word: Death")
	if(start == nil or duration == nil or enabled== nil) then
	hasSWD=false
	else
	hasSWD=true
	SWDTexture:Show()
	end
end
function CheckGlyphs()
	if(not(li == 0)) then
		local enabled, glyphType, glyphTooltipIndex, glyphSpellID = GetGlyphSocketInfo(li);
		local link = GetGlyphLink(li);
		if (link ~= "" and 55682 == glyphSpellID and enabled) then
		   glyphEnabled = true;
		end
	end
	if not(glyphEnabled) then 
		for i=1, NUM_GLYPH_SLOTS do
		 local enabled, glyphType, glyphTooltipIndex, glyphSpellID, icon = GetGlyphSocketInfo(i);
		 if (enabled and 55682 == glyphSpellID) then
		  local link = GetGlyphLink(i);
		  if ( link ~= "") then
		   glyphEnabled = true;
		   li=i;
		   break;
		  end
		 end
		end
	end
	if(not(glyphEnabled)) then
		li = 0;
	end
end
function CheckPlayerCooldown()
	local enabled = false
	local start = 0
	local duration = 0
	start, duration, enabled = GetSpellCooldown("Shadow Word: Death")
	if start then
		SWDTexture:Show()
		if start ~= 0 and not didReset then
			onCooldown=true
			local timeV = GetTime();
			local coolDwn2 = (timeV-TimeSinceSWD);
			local coolDwn = duration-(timeV-start);
			if didCast then
				if(glyphEnabled) then
					if(coolDwn2>1)then
						didCast = false;
					end
					if(coolDwn > 6) then
						didReset = false;
						SWDTexture:SetVertexColor(0.15, 0.15, 0.15);
					else
						didReset = true;
						SWDTexture:SetVertexColor(0.15, 0.15, 0.15);
					end
				elseif(not(glyphEnabled) and coolDwn <= 10) then
					SWDTexture:SetVertexColor(0.15, 0.15, 0.15);
					didCast =false;
				end  
			end
			SWDTEXT:SetText(round(coolDwn,1));
		else
			onCooldown=false
			if(didCast) then
				didCast = false;
				didReset = true;
			end  
			if (didReset) then 
				local tim =GetTime()
				local coolDwn=0;
				coolDwn = cooldownTime-(tim-TimeSinceSWD);
				local collDwn2=6-(tim-TimeSinceSWD);
				if(collDwn2>0)then
					SWDTEXT:SetText(round(collDwn2,1));
					SWDTexture:SetVertexColor(0.6, 0.1, 0.1);
				elseif(collDwn2<-4)then
					SWDTexture:SetVertexColor(1, 1, 1);
					SWDTEXT:SetText(defaultText);
				else
					SWDTexture:SetVertexColor(0.1, 0.6, 0.1);
					SWDTEXT:SetText(defaultText);
				end
			else
				SWDTexture:SetVertexColor(1, 1, 1);
				SWDTEXT:SetText(defaultText)
				lastCooldwn=0;
				didReset=false
			end
		end
	else
		SWDTexture:Hide()
		SWDTEXT:SetText(defaultText)
	end
return 
end
function round(num, idp)
  local mult = 10^(idp or 0)
  local rnd = floor(num * mult + 0.5) / mult
  if(mod(rnd, 1) == 0) then
	rnd=rnd..".0"
  end
  return rnd
end